<template>
  <div class="mt-3">
    <b-button-group>
      <b-button @click="goTo(urlNameDetail, prevId)" v-if="showPrevBtn">Précédent</b-button>
      <b-button @click="goTo(urlReturn)">Retour</b-button>
      <b-button @click="goTo(urlNameDetail, nextId)" v-if="showNextBtn">Suivant</b-button>
    </b-button-group>
  </div>
</template>
<script>
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";
export default {
  props: ["champs", "urlNameDetail", "urlReturn", "moduleName", "idFiche", "listProducts"],
  mounted: function() {
    this.checkPrevNext();
  },
  data() {
    return {
      prevId: null,
      nextId: null,
      showNextBtn: true,
      showPrevBtn: true,
      productsListNav: [],
      nbFiches: 0
    };
  },
  methods: {
    checkPrevNext() {
      // récupérer la liste des fiches
      // soit on gère avec les catégories ou pas
      let payLoad = {
        // categorie: this.champs["categorie"],
        // scat1: this.champs["scat1"],
        // scat2: this.champs["scat2"],
        // scat3: this.champs["scat3"]
      };

      if (this.listProducts && this.listProducts.length > 0) {
        this.productsListNav = this.listProducts;
        this.constructProductsNav();
      } else {
        // récupération de la liste via un call
        this.$axios
          .post(URL_DATAS_ACTIV + this.moduleName, payLoad)
          .then(response => {
            this.productsListNav = response.data.data;
            this.constructProductsNav();
          })
          .catch(error => {
            console.log("error", error);
          });
      }
    },

    constructProductsNav() {
      // récupérer le nombre de fiches
      this.nbFiches = this.productsListNav.length;

      // vérifier si on est sur la première fiche
      // gérer les status d'affichage des boutons
      if (this.productsListNav[0].id === this.idFiche) {
        this.showPrevBtn = false;
      }
      // vérifier si on est sur la dernière fiche
      if (this.productsListNav[this.productsListNav.length - 1].id === this.idFiche) {
        this.showNextBtn = false;
      }
      // récupérer les ID suivant et précédent pour la navigation
      this.productsListNav.forEach((fiche, idx) => {
        if (parseInt(fiche.id) === parseInt(this.idFiche)) {
          if (this.showPrevBtn == true) {
            this.prevId = this.productsListNav[idx - 1].id;
          }
          if (this.showNextBtn == true) {
            this.nextId = this.productsListNav[idx + 1].id;
          }
        }
      });
    },

    goTo(link, id) {
      if (id) {
        // this.$router.push({ name: link, params: { id: id } });
        console.log("aaa", this.champs);
        console.log("link", link);

        if (this.champs["scat3"] !== "" && this.champs["scat3"] !== null) {
          this.$router.push({ name: link, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], scat2: this.champs["scat2"], scat3: this.champs["scat3"], listProducts: this.listProducts, id: id } });
        } else if (this.champs["scat2"] !== "" && this.champs["scat2"] !== null) {
          this.$router.push({ name: link, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], scat2: this.champs["scat2"], listProducts: this.listProducts, id: id } });
        } else if (this.champs["scat1"] !== "" && this.champs["scat1"] !== null) {
          this.$router.push({ name: link, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], listProducts: this.listProducts, id: id } });
        } else if (this.champs["categorie"] !== "" && this.champs["categorie"] !== null) {
          this.$router.push({ name: link, params: { categorie: this.champs["categorie"], listProducts: this.listProducts, id: id } });
        }
      } else {
        this.$router.push({ name: this.urlReturn, params: { listProducts: this.listProducts } });

        // avec gestion des catégories mais désactivé pour le moment

        // if (this.champs["scat3"] !== "" && this.champs["scat3"] !== null) {
        //   this.$router.push({ name: this.urlReturn, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], scat2: this.champs["scat2"], scat3: this.champs["scat3"], listProducts: this.listProducts } });
        // } else if (this.champs["scat2"] !== "" && this.champs["scat2"] !== null) {
        //   this.$router.push({ name: this.urlReturn, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], scat2: this.champs["scat2"], listProducts: this.listProducts } });
        // } else if (this.champs["scat1"] !== "" && this.champs["scat1"] !== null) {
        //   this.$router.push({ name: this.urlReturn, params: { categorie: this.champs["categorie"], scat1: this.champs["scat1"], listProducts: this.listProducts } });
        // } else if (this.champs["categorie"] !== "" && this.champs["categorie"] !== null) {
        //   this.$router.push({ name: this.urlReturn, params: { categorie: this.champs["categorie"], listProducts: this.listProducts } });
        // }
      }
    }
  }
};
</script>
